Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management
Class MBeanServerInvocationHandler

    java.lang.Object
      javax.management.MBeanServerInvocationHandler

All Implemented Interfaces:
  InvocationHandler

    public class MBeanServerInvocationHandler

extends Object
implements InvocationHandler

`InvocationHandler` that forwards methods in an MBean's management interface through the MBean server to the MBean.

Given an `MBeanServerConnection`, the `ObjectName` of an MBean within that MBean server, and a Java interface `Intf` that describes the management interface of the MBean using the patterns for a Standard MBean, this class can be used to construct a proxy for the MBean. The proxy implements the interface `Intf` such that all of its methods are forwarded through the MBean server to the MBean.

If you have an MBean server `mbs` containing an MBean with `ObjectName` `name`, and if the MBean's management interface is described by the Java interface `Intf`, you can construct a proxy for the MBean like this:

     Intf proxy = (Intf)
         MBeanServerInvocationHandler.newProxyInstance(mbs,
                                                       name,
                                                       Intf.class,
                                                       false);

Suppose, for example, `Intf` looks like this:

     public interface Intf {
         public String getSomeAttribute();
         public void setSomeAttribute(String value);
         public void someOperation(String param1, int param2);
     }

Then you can execute:

- `proxy.getSomeAttribute()` which will result in a call to `mbs.``getAttribute``(name, "SomeAttribute")`.
- `proxy.setSomeAttribute("whatever")` which will result in a call to `mbs.``setAttribute``(name, new Attribute("SomeAttribute", "whatever"))`.
- `proxy.someOperation("param1", 2)` which will be translated into a call to `mbs.``invoke``(name, "someOperation", <etc>)`.

If the last parameter to `newProxyInstance` is `true`, then the MBean is assumed to be a `NotificationBroadcaster` or `NotificationEmitter` and the returned proxy will implement `NotificationEmitter`. A call to `NotificationBroadcaster.addNotificationListener(javax.management.NotificationListener, javax.management.NotificationFilter, java.lang.Object)` on the proxy will result in a call to `MBeanServerConnection.addNotificationListener(ObjectName, NotificationListener, NotificationFilter, Object)`, and likewise for the other methods of `NotificationBroadcaster` and `NotificationEmitter`.

The methods `Object.toString()`, `Object.hashCode()`, and `Object.equals(Object)`, when invoked on a proxy using this invocation handler, are forwarded to the MBean server as methods on the proxied MBean. This will only work if the MBean declares those methods in its management interface.

Since:
  1.5

Constructor Summary
`MBeanServerInvocationHandler(MBeanServerConnection connection, ObjectName objectName)` Invocation handler that forwards methods through an MBean server.

Method Summary
`Object` | `invoke(Object proxy, Method method, Object[] args)` Processes a method invocation on a proxy instance and returns the result.
`static Object` | `newProxyInstance(MBeanServerConnection connection, ObjectName objectName, Class interfaceClass, boolean notificationBroadcaster)` Return a proxy that implements the given interface by forwarding its methods through the given MBean server to the named MBean.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MBeanServerInvocationHandler

    public MBeanServerInvocationHandler(MBeanServerConnection connection,
                                        ObjectName objectName)

  Invocation handler that forwards methods through an MBean server. This constructor may be called instead of relying on `newProxyInstance(javax.management.MBeanServerConnection, javax.management.ObjectName, java.lang.Class, boolean)`, for instance if you need to supply a different `ClassLoader` to `Proxy.newProxyInstance`.

  Parameters:
    `connection` - the MBean server connection through which all methods of a proxy using this handler will be forwarded.
    `objectName` - the name of the MBean within the MBean server to which methods will be forwarded.

Method Detail

### newProxyInstance

    public static Object newProxyInstance(MBeanServerConnection connection,
                                          ObjectName objectName,
                                          Class interfaceClass,
                                          boolean notificationBroadcaster)

  Return a proxy that implements the given interface by forwarding its methods through the given MBean server to the named MBean.

  This method is equivalent to `Proxy.newProxyInstance``(interfaceClass.getClassLoader(), interfaces, handler)`. Here `handler` is the result of `new MBeanServerInvocationHandler(connection, objectName)`, and `interfaces` is an array that has one element if `notificationBroadcaster` is false and two if it is true. The first element of `interfaces` is `interfaceClass` and the second, if present, is `NotificationEmitter.class`.

  Parameters:
    `connection` - the MBean server to forward to.
    `objectName` - the name of the MBean within `connection` to forward to.
    `interfaceClass` - the management interface that the MBean exports, which will also be implemented by the returned proxy.
    `notificationBroadcaster` - make the returned proxy implement `NotificationEmitter` by forwarding its methods via `connection`.
  Returns:
    the new proxy instance.

### invoke

    public Object invoke(Object proxy,
                         Method method,
                         Object[] args)
                  throws Throwable

  Description copied from interface: `InvocationHandler`
  Processes a method invocation on a proxy instance and returns the result. This method will be invoked on an invocation handler when a method is invoked on a proxy instance that it is associated with.

  Specified by:
    `invoke` in interface `InvocationHandler`
  Parameters:
    `proxy` - the proxy instance that the method was invoked on
    `method` - the `Method` instance corresponding to the interface method invoked on the proxy instance. The declaring class of the `Method` object will be the interface that the method was declared in, which may be a superinterface of the proxy interface that the proxy class inherits the method through.
    `args` - an array of objects containing the values of the arguments passed in the method invocation on the proxy instance, or `null` if interface method takes no arguments. Arguments of primitive types are wrapped in instances of the appropriate primitive wrapper class, such as `java.lang.Integer` or `java.lang.Boolean`.
  Returns:
    the value to return from the method invocation on the proxy instance. If the declared return type of the interface method is a primitive type, then the value returned by this method must be an instance of the corresponding primitive wrapper class; otherwise, it must be a type assignable to the declared return type. If the value returned by this method is `null` and the interface method's return type is primitive, then a `NullPointerException` will be thrown by the method invocation on the proxy instance. If the value returned by this method is otherwise not compatible with the interface method's declared return type as described above, a `ClassCastException` will be thrown by the method invocation on the proxy instance.
  Throws:
    `Throwable` - the exception to throw from the method invocation on the proxy instance. The exception's type must be assignable either to any of the exception types declared in the `throws` clause of the interface method or to the unchecked exception types `java.lang.RuntimeException` or `java.lang.Error`. If a checked exception is thrown by this method that is not assignable to any of the exception types declared in the `throws` clause of the interface method, then an `UndeclaredThrowableException` containing the exception that was thrown by this method will be thrown by the method invocation on the proxy instance.
  See Also:
    `UndeclaredThrowableException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.